## osra 2.1.3

=== dict/Makefile ===
#
# This makefile targets the installation of architecture-independent data.
#

include ../Makefile.inc

install: spelling.txt superatom.txt
	$(INSTALL_DIR) $(DESTDIR)$(datadir)
	$(INSTALL_DATA) $? $(DESTDIR)$(datadir)

uninstall:
	$(RM) -f $(DESTDIR)$(datadir)/spelling.txt
	$(RM) -f $(DESTDIR)$(datadir)/superatom.txt
	
../Makefile.inc: ../Makefile.inc.in ../config.status
	cd .. && ./config.status

=== doc/Makefile ===
#
# This makefile targets the compilation and installation of poject documentation.
#
# We provide compiled documentation on purpose, to reduce the number of dependencies (see linux/debian/control).
#

include ../Makefile.inc

HTML_DOC_DIR=html
NATURALDOCS_DIR=nd

all:

ifdef NATURALDOCS
all: $(HTML_DOC_DIR)/index.html

$(HTML_DOC_DIR)/index.html:
	mkdir -p $(HTML_DOC_DIR) $(NATURALDOCS_DIR)
	$(NATURALDOCS) -i ../src -o HTML $(HTML_DOC_DIR) -p $(NATURALDOCS_DIR)
endif

ifdef XSLTPROC
all: $(NAME).1 $(NAME).html

$(NAME).1: manual.sgml
#	This command has been taken from http://www.debian.org/doc/manuals/maint-guide/ch-dother.en.html#s-manpagexml:
	$(XSLTPROC) --nonet \
		--param make.year.ranges 1 \
		--param make.single.year.ranges 1 \
		--param man.charmap.use.subset 0 \
		http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl \
		$?

$(NAME).html: manual.sgml
	$(XSLTPROC) --nonet \
		--param make.year.ranges 1 \
		--param make.single.year.ranges 1 \
		--param man.charmap.use.subset 0 \
		http://docbook.sourceforge.net/release/xsl/current/html/docbook.xsl \
		$? > $@

install: $(NAME).1
	$(INSTALL_DIR) $(DESTDIR)$(mandir)/man1
	$(INSTALL_DATA) $? $(DESTDIR)$(mandir)/man1
endif

uninstall:
	$(RM) -f $(DESTDIR)$(mandir)/man1/$(NAME).1

clean:
	$(RM) -Rf $(HTML_DOC_DIR) $(NAME).1 $(NAME).html

distclean:
	$(RM) -Rf $(NATURALDOCS_DIR) manual.sgml

../Makefile.inc: ../Makefile.inc.in ../config.status
	cd .. && ./config.status

=== src/Makefile ===
#
# This makefile is responsible for building the executable.
#

include ../Makefile.inc
include Makefile.dep

.PHONY: clean_obj

LIB_VERSION	:= $(LIB_MAJOR_VERSION).$(LIB_MINOR_VERSION).$(LIB_PATCH_VERSION)

TARGETS		:= osra$(EXEEXT)

OBJ_LIB		:=  osra_lib.o osra_grayscale.o osra_fragments.o osra_segment.o osra_labels.o osra_thin.o osra_common.o osra_stl.o osra_structure.o osra_anisotropic.o osra_ocr.o osra_openbabel.o mcdlutil.o unpaper.o osra_reaction.o

ifdef TESSERACT_LIB
OBJ_LIB		+= osra_ocr_tesseract.o
endif

OBJ_CLI		:= $(OBJ_LIB) osra.o

ifdef OSRA_LIB
TARGETS		+= libosra.a libosra$(SHAREDEXT)
endif

ifdef OSRA_JAVA
OBJ_JAVA	:= $(OBJ_LIB) osra_java.o
TARGETS		+= libosra_java$(SHAREDEXT)
endif

ifdef OSRA_ANDROID
OBJ_ANDROID	:= $(OBJ_LIB) osra.o
endif

all:
# From here: http://stackoverflow.com/questions/5584872/complex-conditions-check-in-makefile/5586785#5586785
ifneq ($(or $(OSRA_LIB),$(OSRA_JAVA),$(OSRA_ANDROID)),)
	$(RM) -f $(OBJ_CLI)
endif
	$(MAKE) osra$(EXEEXT)
ifdef OSRA_LIB
	$(RM) -f $(OBJ_LIB)
	$(MAKE) libosra.a
	$(MAKE) libosra$(SHAREDEXT)
endif
ifdef OSRA_JAVA
	$(RM) -f $(OBJ_JAVA)
	$(MAKE) libosra_java$(SHAREDEXT)
endif
ifdef OSRA_ANDROID
	$(RM) -f $(OBJ_ANDROID)
	$(MAKE) libosra_andriod$(SHAREDEXT)
endif
#	We have to update the timestaps of the targets, otherwise "install" target will try to re-link and will cause missed symbols:
	touch $(TARGETS)

osra$(EXEEXT): $(OBJ_CLI)
	$(LINK.cpp) -o $@ $(OBJ_CLI) $(LIBS)

ifdef OSRA_LIB
libosra.a: CXXFLAGS += -fPIC -DOSRA_LIB
libosra.a: $(OBJ_LIB)
	$(AR) cru $@ $(OBJ_LIB)
	$(RANLIB) $@

libosra$(SHAREDEXT): CXXFLAGS += -fPIC -DOSRA_LIB
libosra$(SHAREDEXT): $(OBJ_LIB)
	$(LINK.cpp) $(LDSHAREDFLAGS) -o $@ $(OBJ_LIB) $(LIBS)
endif

ifdef OSRA_JAVA
libosra_java$(SHAREDEXT): CXXFLAGS += -fPIC -DOSRA_LIB -DOSRA_JAVA
libosra_java$(SHAREDEXT): $(OBJ_JAVA)
	$(LINK.cpp) $(LDSHAREDFLAGS) -o $@ $(OBJ_JAVA) $(LIBS)
endif

ifdef OSRA_ANDROID
libosra_andriod$(SHAREDEXT): CXXFLAGS += -fPIC -DOSRA_LIB -DOSRA_ANDROID
libosra_andriod$(SHAREDEXT): $(OBJ_ANDROID)
	$(LINK.cpp) $(LDSHAREDFLAGS) -o $@ $(OBJ_ANDROID) $(LIBS)
endif

Makefile.dep: ../Makefile.inc $(wildcard *.cpp)
	$(CXX) $(CPPFLAGS) -MM $^ > Makefile.dep 

# Correct installation for Cygwin/MinGW also needs handling of libosra.dll.a, which is not done here:
install: $(TARGETS)
	$(INSTALL_DIR) $(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) osra$(EXEEXT) $(DESTDIR)$(bindir)
ifdef OSRA_LIB
	$(INSTALL_DIR) $(DESTDIR)$(libdir) $(DESTDIR)$(includedir) $(DESTDIR)$(libdir)/pkgconfig
	$(INSTALL_PROGRAM) libosra$(SHAREDEXT) $(DESTDIR)$(libdir)/libosra$(SHAREDEXT).$(LIB_VERSION)
	$(LN_S) -f libosra$(SHAREDEXT).$(LIB_VERSION) $(DESTDIR)$(libdir)/libosra$(SHAREDEXT).$(LIB_MAJOR_VERSION)
	$(LN_S) -f libosra$(SHAREDEXT).$(LIB_MAJOR_VERSION) $(DESTDIR)$(libdir)/libosra$(SHAREDEXT)
	$(INSTALL_DATA) libosra.a $(DESTDIR)$(libdir)
	$(INSTALL_DATA) osra_lib.h $(DESTDIR)$(includedir)
	$(INSTALL_DATA) ../package/linux/osra.pc $(DESTDIR)$(libdir)/pkgconfig
endif
ifdef OSRA_JAVA
	$(INSTALL_DIR) $(DESTDIR)$(libdir)
	$(INSTALL_PROGRAM) libosra_java$(SHAREDEXT) $(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT).$(LIB_VERSION)
	$(LN_S) -f libosra_java$(SHAREDEXT).$(LIB_VERSION) $(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT).$(LIB_MAJOR_VERSION)
	$(LN_S) -f libosra_java$(SHAREDEXT).$(LIB_MAJOR_VERSION) $(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT)
endif

# "install" and "make" tools auomatically autodetect the extension for executables, but "rm" needs extension correction.
uninstall:
	-$(RM) -f \
		$(DESTDIR)$(bindir)/osra$(EXEEXT) \
		$(DESTDIR)$(libdir)/libosra$(SHAREDEXT).$(LIB_VERSION) \
		$(DESTDIR)$(libdir)/libosra$(SHAREDEXT).$(LIB_MAJOR_VERSION) \
		$(DESTDIR)$(libdir)/libosra$(SHAREDEXT) \
		$(DESTDIR)$(libdir)/libosra.a \
		$(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT).$(LIB_VERSION) \
		$(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT).$(LIB_MAJOR_VERSION) \
		$(DESTDIR)$(libdir)/libosra_java$(SHAREDEXT)
		$(DESTDIR)$(includedir)/osra_lib.h \
		$(DESTDIR)$(libdir)/pkgconfig/osra.pc

clean:
	-$(RM) -f *.o osra$(EXEEXT) libosra*.*

distclean: clean
	-$(RM) -f config.h Makefile.dep

../Makefile.inc: ../Makefile.inc.in ../config.status
	cd .. && ./config.status

=== addons/lib_sample/Makefile ===
CXX		:= g++
LD		:= g++

CXXFLAGS	:= -g3 -ggdb -O0 -DOSRA_LIB
CPPFLAGS	:= -I../../src
LDFLAGS		:= -L../../src -L/usr/local/lib

LIBS		:= -losra

.PHONY: all clean

.SUFFIXES: .c .cpp

OBJ			= lib_sample.o

all: lib_sample

#	LD_LIBRARY_PATH=../../src ./lib_sample /usr/local/lib

lib_sample: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	rm -f *.o lib_sample

=== test/bugs/gcc_and_graphicsmagick_test/Makefile ===
CXX		:= g++
LD		:= g++
RM		:= /bin/rm

CXXFLAGS	:= -g3 -O2
CPPFLAGS	:= -I/usr/include/GraphicsMagick
LDFLAGS		:= -L/usr/lib

LIBS		:= -lGraphicsMagick++ 

.PHONY: all clean

.SUFFIXES: .c .cpp

OBJ		= test.o

all: test

test: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	$(RM) -f *.o test

=== test/bugs/gocr_quality_regression_test/Makefile ===
CXX		:= g++
LD		:= g++

CXXFLAGS	:= -g3 -O2
CPPFLAGS	:= -I/usr/include/gocr
LDFLAGS		:= -L/usr/lib
LIBS		:= -lPgm2asc -lnetpbm

OBJ		= osra_gocr.o

.PHONY: all clean

.SUFFIXES: .c .cpp

all: test

test: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	$(RM) -f *.o test

=== test/bugs/ocrad_api_regression_test/Makefile ===
CXX		:= g++
LD		:= g++

CXXFLAGS	:= -g3 -O2
CPPFLAGS	:= -I/usr/include/ocrad
LDFLAGS		:= -L/usr/lib
LIBS		:= -locrad

OBJ		= osra_ocr.o

.PHONY: all clean

.SUFFIXES: .c .cpp

all: test

test: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	$(RM) -f *.o test

=== test/bugs/tesseract_init_test/Makefile ===
CXX		:= g++
LD		:= g++
RM		:= /bin/rm

CXXFLAGS	:= -g3 -ggdb -O0
CPPFLAGS	:= 
LDFLAGS		:= -L/usr/lib

LIBS		:= -ltesseract_api

.PHONY: all clean

.SUFFIXES: .c .cpp

OBJ		= test.o

all:
	rm -f *.o
	$(MAKE) test_local
	rm -f *.o
	$(MAKE) test_global
	./test_global > 1
	./test_local > 2
	diff -au 1 2

test_local: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

test_global: CXXFLAGS += -DTESS_GLOBAL_INSTANCE
test_global: $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	$(RM) -f *.o test_*

=== debian/changelog ===
osra (2.1.3-3build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:10:22 +1100

osra (2.1.3-3build2) noble; urgency=medium

  * No-change rebuild against libpoppler-cpp0t64

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 21 Mar 2024 17:13:41 +1300

osra (2.1.3-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:47:33 +0000

osra (2.1.3-3) unstable; urgency=medium

  * libosra-dev: add dependency on libosra2 (Closes: #1035455)

 -- Andrius Merkys <merkys@debian.org>  Thu, 04 May 2023 02:31:03 -0400

osra (2.1.3-2) unstable; urgency=medium

  * Add complete texts of CeCILL and CeCILL-C licenses.

 -- Andrius Merkys <merkys@debian.org>  Fri, 16 Sep 2022 01:24:16 -0400

osra (2.1.3-1) unstable; urgency=medium

  * Initial release (closes: #682760)

 -- Andrius Merkys <merkys@debian.org>  Tue, 23 Aug 2022 04:26:38 -0400

=== debian/control ===
Source: osra
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Daniel Leidert <dleidert@debian.org>,
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libpgm2asc-dev,
 libgraphicsmagick++1-dev,
 libocrad-dev (>= 0.28-2),
 libopenbabel-dev,
 libpoppler-cpp-dev,
 libpotrace-dev,
 libtclap-dev,
Standards-Version: 4.6.1
Homepage: https://sourceforge.net/p/osra/wiki/Home/
Vcs-Browser: https://salsa.debian.org/debichem-team/osra
Vcs-Git: https://salsa.debian.org/debichem-team/osra.git

Package: osra
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: optical structure recognition
 OSRA is a utility designed to convert graphical representations of
 chemical structures, as they appear in journal articles, patent documents,
 textbooks, trade magazines etc., into SMILES (Simplified Molecular
 Input Line Entry Specification) - a computer recognizable molecular structure
 format. OSRA can read a document in any of the over 90 graphical formats
 parseable by ImageMagick - including GIF, JPEG, PNG, TIFF, PDF, PS etc., and
 generate the SMILES representation of the molecular structure images
 encountered within that document.

Package: libosra2
Architecture: any
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: optical structure recognition (shared library)
 OSRA is a utility designed to convert graphical representations of
 chemical structures, as they appear in journal articles, patent documents,
 textbooks, trade magazines etc., into SMILES (Simplified Molecular
 Input Line Entry Specification) - a computer recognizable molecular structure
 format. OSRA can read a document in any of the over 90 graphical formats
 parseable by ImageMagick - including GIF, JPEG, PNG, TIFF, PDF, PS etc., and
 generate the SMILES representation of the molecular structure images
 encountered within that document.

Package: libosra-dev
Architecture: any
Section: libdevel
Depends:
 libosra2 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Description: optical structure recognition (development files)
 OSRA is a utility designed to convert graphical representations of
 chemical structures, as they appear in journal articles, patent documents,
 textbooks, trade magazines etc., into SMILES (Simplified Molecular
 Input Line Entry Specification) - a computer recognizable molecular structure
 format. OSRA can read a document in any of the over 90 graphical formats
 parseable by ImageMagick - including GIF, JPEG, PNG, TIFF, PDF, PS etc., and
 generate the SMILES representation of the molecular structure images
 encountered within that document.

=== debian/rules ===
#!/usr/bin/make -f

export JAVA_HOME=/usr/lib/jvm/default-java

%:
	dh $@

# Autoreconf fails, build has to use embedded configure script:
# Reference: https://sourceforge.net/p/osra/bugs/20/
override_dh_autoreconf:

# --enable-java is not added as it causes FTBFS
override_dh_auto_configure:
	LIBS=-lpng ./configure --prefix=/usr --datarootdir=\$${prefix}/share/osra --enable-lib --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) --enable-openmp

=== debian/watch ===
version=4
https://sf.net/osra/ osra-@ANY_VERSION@@ARCHIVE_EXT@
